
#define   MAGIC     20051214

//-------    --------------------------------

extern string _Parameters_Trade = "-----  ";
extern int    StopLoss   = 25;     //   
extern int    TakeProfit = 60;     //   
extern double Lots       = 0.1;    //   
extern int    Slippage   = 3;      //  

extern string _Parameters_Expert = "-----  ";
extern int zazor = 20;
extern color clOpenBuy    = LightBlue;    //   
extern color clOpenSell   = LightCoral;   //   
extern color clModifyBuy  = Aqua;         //   
extern color clModifySell = Tomato;       //   
extern color clCloseBuy   = Blue;         //   
extern color clCloseSell  = Red;          //   

//-------    ----------------------------
int j = 0;
bool ft = true;
int blok = 0;
int s = 0;
int b = 0;
int top = 0;
int del = 0;

double MidL = 0,MLP = 0,MLM = 0;
string dw = " ";

bool   UseSound=False;
int bs=0;
string NameFileSound="";

//-------    --------------------------------
#include <a-TLE_v.1.6.mqh>
#include <stdlib.mqh>


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() 
{

//double ldStop=0, ldTake=0;
//  }


//----
   j=j+1; 
 
   if((Minute()==0) && (Seconds()<=15))
   {
      j=0;
   }

   if((Hour()==0 && Minute()<5) || (ft==true))
   {
      blok=0; s=0; b=0;
      
      if(ft==true)
      {
         top = MathRound((Hour()*60+Minute())/Period())+1;
      } else {
         top=1;
      }
      
      MidL=Close[top];
      MLP=MidL+zazor*Point;
      MLM=MidL-zazor*Point;

      MoveHLine("MidL",Time[1],MidL,Time[5],MidL,Gold,1,STYLE_DOT);
      MoveHLine("MLP",Time[1],MLP,Time[5],MLP,Lime,1,STYLE_DOT);
      MoveHLine("MLM",Time[1],MLM,Time[5],MLM,Magenta,1,STYLE_DOT);
      
      ft=false;
   }

   if(s + b == 0) {
      blok=0;
   } else {
      blok=1;
   }

   if(DayOfWeek()==2) dw="Monday";
   if(DayOfWeek()==3) dw="Tuesday";
   if(DayOfWeek()==4) dw="Wednesday";
   if(DayOfWeek()==5) dw="Thursday";
   if(DayOfWeek()==6) dw="Friday";
   
   if(Close[1]>MLP) del=MathRound((Close[1]-MLP)/Point);
   if(Close[1]<MLM) del=MathRound((MLM-Close[1])/Point);
   if(Close[1]<=MLP && Close[1]>=MLM) del=0;
                                         
   Comment("Data: ",Year(),".",Month(),".",Day(),"  Day=",dw,"  Time ",Hour(),":",Minute(),"  Tiks=",j,"\n","Blok=",blok,
           "  Delta=",del,"  Min=",MLM,"  Max=",MLP,"  Price=",Close[1]); 
           
   OpenPosition();
   if (UseTrailing) TrailingPositions();
         
   
//----
   return(0);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                            |
//+------------------------------------------------------------------+
void MoveHLine(string name, datetime time, double price, datetime time1, double price1, 
                  int objcolor, int width, int style)
{
   if(ObjectFind(name)==-1)
   {
      ObjectCreate(name,OBJ_HLINE,0,time,price);
      ObjectSet(name, OBJPROP_COLOR, objcolor);
      ObjectSet(name, OBJPROP_WIDTH, width);
      ObjectSet(name, OBJPROP_STYLE, style);
   } else {
      ObjectMove(name, 1, time1, price1);
   }
}
           
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OpenPosition() {
   double ldStop = 0, ldTake = 0;
   int    bs = GetTradeSignal();

   if(!ExistPosition() && (bs != 0))
   {
      if (bs>0)
      {
         if (StopLoss!=0) ldStop=Ask-StopLoss*Point;
         if (TakeProfit!=0) ldTake=Ask+TakeProfit*Point;
         SetOrder(OP_BUYSTOP, MLM, ldStop, ldTake);
         b=b+1;
      }
      
      if (bs<0)
      {
         if (StopLoss!=0) ldStop=Bid+StopLoss*Point;
         if (TakeProfit!=0) ldTake=Bid-TakeProfit*Point;
         SetOrder(OP_SELLSTOP, MLP, ldStop, ldTake);
         s=s+1;
      }
   }
}

//+------------------------------------------------------------------+
//|   :                                      |
//|    1 -                                                    |
//|    0 - ,                                           |
//|   -1 -                                                   |
//+------------------------------------------------------------------+
int GetTradeSignal() 
{
   if(Hour()>0 && blok==0)
   {
      if(DayOfWeek()==6) return(0);
      if(del>5 && Close[1]>MLP)
      {
         return(-1);
      }
      if(del>5 && Close[1]<MLM)
      {
         return(1);
      }
   }
   return(0);
  }      
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
bool ExistPosition() {
   for (int i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC)
         {
            if (OrderType()==OP_BUY || OrderType()==OP_SELL) 
            {
               return(true);
            }
         }
      }
   }
   return(false);
}

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   pp     -                                                   |
//|   ldStop -                                            |
//|   ldTake -                                            |
//+------------------------------------------------------------------+
void SetOrder(int op, double pp, double ldStop, double ldTake) {
   color clOpen = Red;

   if(op==OP_BUY)
   { 
      clOpen=clOpenBuy; 
   } else {
      clOpen=clOpenSell;
   }
   OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,"",MAGIC,0,clOpen);
}

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }


